/**************************************************************************************************
GAUSS CODE TO ESTIMATE A FSMS(2)-AR MODEL AS IN 
E.OTRANTO (2015): "Adding Flexibility to Markov Switching Models" CRENoS WP 2015/09
**************************************************************************************************/


new;
t=272;@length of the series@
nf=8; @number of final observations to be erased@
load v[t,1]=c:\users\edoardo\dropbox\mio\fms\log_gdp.txt;  @load the data@
y=((v[5:t-nf,1])-(v[4:t-nf-1]))*100;
xr=(y-meanc(y))/stdc(y);  @wsd function@
t=rows(y);

                    
pmax=12;
n=2^3;
b=-1|ln(1)|ln(3)|0|1|3|3|-1|-1|meanc(y)|meanc(y);   @starting values@
b=    -0.031883054 |
      0.89374948 |
      0.86414875 |
     -0.10678465 |
       1.2513024 |
     -0.21760335 |
       4.0968111 |
      0.46222985 |
     -0.29476982 |
       3.6108590 |
       1.7314574 |
       2.3259603 ;


holes=0;    @position of parameters constrained to be 0;
INSERT holes=0 IF YOU DO NOT IMPOSE CONSTRAINTS.
@


/*******************
END OF THE USER PART
********************/

rh=rows(holes);

/*************************************************************************
                       ESTIMATION
**************************************************************************/
library optmum;
_opmiter=500;
{x,likv,gr,err}=optmum(&ll,b);
hes=inv(hessp(&ll,x));

/*=======================================================================
             REPARAMETERIZATION
=======================================================================*/
x0=trans(x);
x0=constr(x0);
mi=x0[1:3];
phi1=x0[4];
phi2=x0[5];
sig=x0[6];
p00=x0[7];
p11=x0[8];
gams=x0[9:10];
cp=x0[11:12];
p01=1-p00;
p10=1-p11;
PS=(p00~p01~0~0~0~0~0~0)|
0~0~(p10~p11)~0~0~(0~0)|
(0~0~0~0~p00~p01~0~0)|
0~0~(0~0)~0~0~(p10~p11)|
(p00~p01~0~0~0~0~0~0)|
0~0~(p10~p11)~0~0~(0~0)|
(0~0~0~0~p00~p01~0~0)|
0~0~(0~0)~0~0~(p10~p11);

/***************************************************************************
                                filtering
****************************************************************************/
s1=zeros(n,t);   @this matrix will contain the probabilities at time t given the information at time t@
s2=zeros(n,t);   @this matrix will contain the probabilities at time t+1 given the information at time t@

gs=zeros(t,2);
mix=zeros(t,n);
mif=zeros(t,2);
yhat=zeros(t,n);

cost1=(2*pi)^(-1/2);
D=(eye(n)-ps')|ones(1,n);
in=zeros(n,1)|1;
s2[.,3]=inv(D'D)*D'in;
eta=zeros(n,1);
      xr=y[2];
tim=3;
   do while tim<=t-1; 
      gs1=inv(1+exp(-gams[1]*(xr-cp[1])));
      gs2=inv(1+exp(-gams[2]*(xr-cp[2])));
      gs[tim,.]=gs1~gs2;
      omega=sig^2;
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs1+ex2*(1-gs1);
      mix[tim,1]=mi[1]*gs1+mi[2]*(1-gs1);
      yhat[tim,1]=ex;
      eta[1]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs2+ex2*(1-gs2);
      mix[tim,2]=mi[2]*gs2+mi[3]*(1-gs2);
      yhat[tim,2]=ex;
      eta[2]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs1+ex2*(1-gs1);
      mix[tim,3]=mi[1]*gs1+mi[2]*(1-gs1);
      yhat[tim,3]=ex;
      eta[3]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs2+ex2*(1-gs2);
      mix[tim,4]=mi[2]*gs2+mi[3]*(1-gs2);
      yhat[tim,4]=ex;
      eta[4]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs1+ex2*(1-gs1);
      mix[tim,5]=mi[1]*gs1+mi[2]*(1-gs1);
      yhat[tim,5]=ex;
      eta[5]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs2+ex2*(1-gs2);
      mix[tim,6]=mi[2]*gs2+mi[3]*(1-gs2);
      yhat[tim,6]=ex;
      eta[6]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs1+ex2*(1-gs1);
      mix[tim,7]=mi[1]*gs1+mi[2]*(1-gs1);
      yhat[tim,7]=ex;
      eta[7]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs2+ex2*(1-gs2);
      mix[tim,8]=mi[2]*gs2+mi[3]*(1-gs2);
      yhat[tim,8]=ex;
      eta[8]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      
      mifx=s2[.,tim].*(mix[tim,.]');
      mif[tim,.]=(mifx[1]+mifx[3]+mifx[5]+mifx[7])~(mifx[2]+mifx[4]+mifx[6]+mifx[8]);  
  snum=s2[.,tim].*eta;
   fy=ones(1,n)*snum;
   s1[.,tim]=snum/fy;



  s2[.,tim+1]=ps'*s1[.,tim];
  xr=sumc(s1[.,tim].*(mix[tim,.]'));  
   tim=tim+1;
   endo;
      gs1=inv(1+exp(-gams[1]*(xr-cp[1])));
      gs2=inv(1+exp(-gams[2]*(xr-cp[2])));
      gs[tim,.]=gs1~gs2;
      omega=sig^2;
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs1+ex2*(1-gs1);
      mix[tim,1]=mi[1]*gs1+mi[2]*(1-gs1);
      yhat[tim,1]=ex;
      eta[1]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs2+ex2*(1-gs2);
      mix[tim,2]=mi[2]*gs2+mi[3]*(1-gs2);
      yhat[tim,2]=ex;
      eta[2]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs1+ex2*(1-gs1);
      mix[tim,3]=mi[1]*gs1+mi[2]*(1-gs1);
      yhat[tim,3]=ex;
      eta[3]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs2+ex2*(1-gs2);
      mix[tim,4]=mi[2]*gs2+mi[3]*(1-gs2);
      yhat[tim,4]=ex;
      eta[4]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs1+ex2*(1-gs1);
      mix[tim,5]=mi[1]*gs1+mi[2]*(1-gs1);
      yhat[tim,5]=ex;
      eta[5]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs2+ex2*(1-gs2);
      mix[tim,6]=mi[2]*gs2+mi[3]*(1-gs2);
      yhat[tim,6]=ex;
      eta[6]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs1+ex2*(1-gs1);
      mix[tim,7]=mi[1]*gs1+mi[2]*(1-gs1);
      yhat[tim,7]=ex;
      eta[7]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs2+ex2*(1-gs2);
      mix[tim,8]=mi[2]*gs2+mi[3]*(1-gs2);
      yhat[tim,8]=ex;
      eta[8]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      
      mifx=s2[.,tim].*(mix[tim,.]');
      mif[tim,.]=(mifx[1]+mifx[3]+mifx[5]+mifx[7])~(mifx[2]+mifx[4]+mifx[6]+mifx[8]);  
  snum=s2[.,tim].*eta;
   fy=ones(1,n)*snum;
   s1[.,tim]=snum/fy;

s3=zeros(n,t);   @this matrix will contain the probabilities at time t given the full information@
s3[.,t]=s1[.,t];
tim=t-1;
   do while tim>=1;  
   s3[.,tim]=s1[.,tim].*(PS*(s3[.,tim+1]./s2[.,tim+1]));   
   tim=tim-1;
   endo;
s3=(s3[1,.]+s3[3,.]+s3[5,.]+s3[7,.])'~(s3[2,.]+s3[4,.]+s3[6,.]+s3[8,.])';



grdn=gradfd(&TRANS,x);
cov=grdn*hes*grdn';

se=sqrt(diag(cov));

"Estimates and standard errors:";
x0;
se;


/*************************************************************************
                            standardized residuals 
**************************************************************************/
yhat=(s2').*yhat;
yhat=sumc(yhat');
ehats=y-yhat;
ehats=ehats[3:t,.];
t=rows(ehats);
lag=20;
lb=zeros(2,lag);
i=1;
   do while i<=lag;
   qm=0;
   j=1;
      do while j<=i;
     cl=corrx(ehats[j+1:t]~ehats[1:t-j]);
     cl=cl[1,2]^2;
     qm=qm+cl/(t-j);
      j=j+1;
      endo;
      qm=qm*t*(t+2);
      lb[1,i]=qm;
      lb[2,i]=cdfchic(qm,i);
            if cdfchic(qm,i)>0.05;
      endif;
      i=i+1;
      endo;    


 /***************************************************************************
     model fitting 
***************************************************************************/
np=rows(x);
likv=-ll(x);
AIC=-2/t*(likv-np);
SCH=-2*likv/t+np*ln(t)/t;
"Log-Lik=" likv;
"AIC=" AIC;
"Schwarz=" SCH;
MSE=meanc(ehats.^2);

"MSE:" MSE;

/****@**************************************************************************
                 PROCEDURE TO CONSTRAINTS SOME PARAMETERS TO BE 0
*******************************************************************************/
proc(1)=constr(x0);
local xc,ir,ix,j;
if holes==0;
xc=x0;
else;
xc=zeros(pmax,1);
ir=1;
ix=0;
   j=1;
   do while j<=pmax;
   ix=ix+1;
      hol:
      if j==holes[ir];
      if holes[ir]==pmax and j==pmax;
      goto ehol1;
      endif;
      j=j+1;
      ix=j-ir;
      ir=ir+1;
      if ir>rh;
      ir=rh;
      goto ehol;
      endif;
      goto hol;
      endif;
   ehol:
   xc[j]=x0[ix];
   ehol1:
   j=j+1;
   endo; 
endif;
retp(xc);
endp;

proc trans(x0);
local c,i,x,c1,y,a,b;
x=constr(x0);

c=x;
if holes==0;
y=exp(x);
else;
y=exp(x);
i=1;
   do while i<=rows(holes);
   y[holes[i]]=0;
   i=i+1;
   endo;
endif;

c[1:3]=((x[1])|(x[1]+(y[2]))|((x[1])+(y[2])+(y[3])));
a=x[4]/(1+abs(x[4]));
b=x[5]/(1+abs(x[5]));
c[4]=a+b;
c[5]=-a*b;
c[6]=(y[6]);
c[7:8]=((y[7:8]))./(1+((y[7:8])));
c[9:10]=(y[9:10]);
if holes==0;
c1=zeros(pmax,1);
else;
c1=zeros(pmax,1);
i=1;
   do while i<=rh;
   c1[holes[i]]=1;
   i=i+1;
   endo;
endif;
c=delif(c,c1);  
retp(c);
endp;




/***************************************************************************
              PROCEDURE TO EXPLICIT THE LOG-LIKELIHOOD
****************************************************************************/
proc(1)=ll(x);
local s1,s2,mi,phi1,phi2,phi3,phi4,sig,cost1,D,in,eta,tim,ex,omega,snum,fy,ps,p00,p11,p01,p10,ll,gams,cp,gs1,gs2,ex1,ex2,x0,mix,mif,xr,yhat;
s1=zeros(n,t);   @this matrix will contain the probabilities at time t given the information at time t@
s2=zeros(n,t);   @this matrix will contain the probabilities at time t+1 given the information at time t@
x0=trans(x);
x0=constr(x0);
mi=x0[1:3];
phi1=x0[4];
phi2=x0[5];
sig=x0[6];
p00=x0[7];
p11=x0[8];
gams=x0[9:10];
cp=x0[11:12];

mix=zeros(t,n);
mif=zeros(t,2);
yhat=zeros(n,1);

p01=1-p00;
p10=1-p11;
PS=(p00~p01~0~0~0~0~0~0)|
0~0~(p10~p11)~0~0~(0~0)|
(0~0~0~0~p00~p01~0~0)|
0~0~(0~0)~0~0~(p10~p11)|
(p00~p01~0~0~0~0~0~0)|
0~0~(p10~p11)~0~0~(0~0)|
(0~0~0~0~p00~p01~0~0)|
0~0~(0~0)~0~0~(p10~p11);
ll=0;
cost1=(2*pi)^(-1/2);
D=(eye(n)-ps')|ones(1,n);
in=zeros(n,1)|1;
s2[.,3]=inv(D'D)*D'in;
eta=zeros(n,1);
xr=y[2];
tim=3;
   do while tim<=t-1;
      gs1=inv(1+exp(-gams[1]*(xr-cp[1])));
      gs2=inv(1+exp(-gams[2]*(xr-cp[2])));
      omega=sig^2;
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs1+ex2*(1-gs1);
      yhat[1]=ex;
      mix[tim,1]=mi[1]*gs1+mi[2]*(1-gs1);
      eta[1]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs2+ex2*(1-gs2);
      yhat[2]=ex;
      mix[tim,2]=mi[2]*gs2+mi[3]*(1-gs2);
      eta[2]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs1+ex2*(1-gs1);
      yhat[3]=ex;
     mix[tim,3]=mi[1]*gs1+mi[2]*(1-gs1);
      eta[3]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,1]);
      ex=ex1*gs2+ex2*(1-gs2);
      yhat[4]=ex;
      mix[tim,4]=mi[2]*gs2+mi[3]*(1-gs2);
      eta[4]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs1+ex2*(1-gs1);
      yhat[5]=ex;
      mix[tim,5]=mi[1]*gs1+mi[2]*(1-gs1);
      eta[5]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,1])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs2+ex2*(1-gs2);
      yhat[6]=ex;
      mix[tim,6]=mi[2]*gs2+mi[3]*(1-gs2);
      eta[6]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[1]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs1+ex2*(1-gs1);
      yhat[7]=ex;
      mix[tim,7]=mi[1]*gs1+mi[2]*(1-gs1);
      eta[7]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      ex1=mi[2]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex2=mi[3]+PHI1*(y[tim-1,.]-mif[tim-1,2])+PHI2*(y[tim-2,.]-mif[tim-2,2]);
      ex=ex1*gs2+ex2*(1-gs2);
      yhat[8]=ex;
      mix[tim,8]=mi[2]*gs2+mi[3]*(1-gs2);
      eta[8]=cost1*(det(omega))^(-0.5)*exp(-((y[tim]-ex)'inv(omega)*(y[tim]-ex))/2);
      
      mifx=s2[.,tim].*(mix[tim,.]');
      mif[tim,.]=(mifx[1]+mifx[3]+mifx[5]+mifx[7])~(mifx[2]+mifx[4]+mifx[6]+mifx[8]);  
   snum=s2[.,tim].*eta;
   fy=ones(1,n)*snum;
   ll=ll+ln(fy);
   s1[.,tim]=snum/fy;
  

  s2[.,tim+1]=ps'*s1[.,tim];
  xr=sumc(s1[.,tim].*(mix[tim,.]'));  
   tim=tim+1;
   endo;
snum=s2[.,t].*eta;
fy=ones(1,n)*snum;
   ll=ll+ln(fy);
s1[.,t]=snum/fy;
retp(-ll);
endp; 

