/**************************************************************************************************
GAUSS CODE TO ESTIMATE A FSMS(2)-GARCH MODEL AS IN 
E.OTRANTO (2015): "Adding Flexibility to Markov Switching Models" CRENoS WP 2015/09
**************************************************************************************************/

new;
t1=2840; @length of the data set@
t2=2840; @length of the series to be analyzed@
pmax=13;
nser=1;
res=zeros(t2,nser);
lag=20;
lb=zeros(2*nser,lag);
stat=zeros(nser,4);
lb5=zeros(nser,20);
lb1=zeros(nser,20);
lmt5=zeros(nser,1);
lmt1=zeros(nser,1);
fs=1;
r=fs;
load y[t1,nser+1]=c:\users\edoardo\dropbox\mio\fms\codes\data_nasdaq.txt; @load the data@
y=y[1:t2,.];
y=y[.,2]*100;
dum=(y.<0);
t=rows(y);
ns=2;
b=0.03|0.08|0.53|1|3|1|3|3|0|0|0|0.5|0.5;   @starting coefficients@
b={ -0.027499564
0.096288009
0.78482002
11.679194
9.7436125
7.4108124
6.3453893
0.012681413
-12.398626
1.8876028
26.450944
};
b=b';

holes=4|10; @insert here the position of the coefficients constrained equal to zero. Insert 0 if no constraints are adopted@
rh=rows(holes);
par_f=zeros(rows(b),nser);
par_r=zeros(rows(b),nser);
se_f=zeros(rows(b),nser);

library optmum;
_opmiter=500;
b1=b;
{b1,likv,gr,err}=optmum(&mem,b);
b0=trans(b1);
b0=constr(b0);
Hout0=hessp(&mem,b1);

omega=b0[1:2]|b0[3];
alpha=b0[4];
beta=b0[5];
gam=b0[6];
p11=b0[7];
p22=b0[8];
c=b0[9];
gams=b0[10:11];
cp=b0[12:13];
n=ns^2;

s1=zeros(n,t);   
s2=zeros(n,t);   

mi_f=zeros(t,n);
mi_c=zeros(t,2);
gs=zeros(t,2);

PS=(p11~(1-p11)~0~0)|
(0~0~(1-p22)~p22)|
(p11~(1-p11)~0~0)|
(0~0~(1-p22)~p22);


D=(eye(n)-ps')|ones(1,n);
in=zeros(n,1)|1;
s2[.,1]=inv(D'D)*D'in;
eta=zeros(n,1);
eps=y-c;
   xr=s2[1,1]+s2[1,3];
   gs1=exp(gams[1]+cp[1]*xr)/(1+exp(gams[1]+cp[1]*xr));
   gs2=exp(gams[2]+cp[2]*xr)/(1+exp(gams[2]+cp[2]*xr));
gs[1,.]=gs1~gs2;
mi=(omega[1]/(1-alpha[1]-beta[1]-gam[1]/2))*gs1+(omega[2]/(1-alpha[1]-beta[1]-gam[1]/2))*(1-gs1);
mi_f[1,1]=mi;
eta[1]=1/sqrt(2*pi*mi)*exp(-(eps[1]^2)/(2*mi));
mi=(omega[2]/(1-alpha[1]-beta[1]-gam[1]/2))*gs2+(omega[3]/(1-alpha[1]-beta[1]-gam[1]/2))*(1-gs2);
mi_f[1,2]=mi;
eta[2]=1/sqrt(2*pi*mi)*exp(-(eps[1]^2)/(2*mi));
mi=(omega[1]/(1-alpha[1]-beta[1]-gam[1]/2))*gs1+(omega[2]/(1-alpha[1]-beta[1]-gam[1]/2))*(1-gs1);
mi_f[1,3]=mi;
eta[3]=1/sqrt(2*pi*mi)*exp(-(eps[1]^2)/(2*mi));
mi=(omega[2]/(1-alpha[1]-beta[1]-gam[1]/2))*gs2+(omega[3]/(1-alpha[1]-beta[1]-gam[1]/2))*(1-gs2);
mi_f[1,4]=mi;
eta[4]=1/sqrt(2*pi*mi)*exp(-(eps[1]^2)/(2*mi));
   snum=s2[.,1].*eta;
   fy=ones(1,n)*snum;
   s1[.,1]=snum/(fy);
   s2s=(s1[1,1]+s1[3,1])~(s1[2,1]+s1[4,1]);
   mi_c[1,1]=(s1[1,1]*mi_f[1,1]+s1[3,1]*mi_f[1,3])/s2s[1]; 
   mi_c[1,2]=(s1[2,1]*mi_f[1,2]+s1[4,1]*mi_f[1,4])/s2s[2];
 
   s2[.,2]=ps'*s1[.,1];

I_op=zeros(rows(b),rows(b));
tim=2;
   do while tim<=t-1;
         gr_sc=gradp(&sc_mem,b1);
         I_op=I_op+gr_sc'gr_sc;
   xr=s2[1,tim]+s2[3,tim];
   gs1=exp(gams[1]+cp[1]*xr)/(1+exp(gams[1]+cp[1]*xr));
   gs2=exp(gams[2]+cp[2]*xr)/(1+exp(gams[2]+cp[2]*xr));
gs[tim,.]=gs1~gs2;
        mi=(omega[1]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs1+(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs1);
        mi_f[tim,1]=mi;
        eta[1]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs2+(omega[3]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs2);
         mi_f[tim,2]=mi;
        eta[2]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[1]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs1+(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs1);
         mi_f[tim,3]=mi;
        eta[3]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs2+(omega[3]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs2);
         mi_f[tim,4]=mi;
        eta[4]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
   snum=s2[.,tim].*eta;
   fy=ones(1,n)*snum;
   s1[.,tim]=snum/(fy);
   s2s=(s1[1,tim]+s1[3,tim])~(s1[2,tim]+s1[4,tim]);
   mi_c[tim,1]=(s1[1,tim]*mi_f[tim,1]+s1[3,t]*mi_f[tim,3])/s2s[1]; 
   mi_c[tim,2]=(s1[2,tim]*mi_f[tim,2]+s1[4,tim]*mi_f[tim,4])/s2s[2];

   s2[.,tim+1]=ps'*s1[.,tim];

   tim=tim+1;
   endo;  
         gr_sc=gradp(&sc_mem,b1);
         I_op=I_op+gr_sc'gr_sc;
   xr=s2[1,tim]+s2[3,tim];
   gs1=exp(gams[1]+cp[1]*xr)/(1+exp(gams[1]+cp[1]*xr));
   gs2=exp(gams[2]+cp[2]*xr)/(1+exp(gams[2]+cp[2]*xr));
gs[tim,.]=gs1~gs2;
        mi=(omega[1]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs1+(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs1);
        mi_f[tim,1]=mi;
        eta[1]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs2+(omega[3]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs2);
         mi_f[tim,2]=mi;
        eta[2]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[1]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs1+(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs1);
         mi_f[tim,3]=mi;
        eta[3]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs2+(omega[3]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs2);
         mi_f[tim,4]=mi;
        eta[4]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
   snum=s2[.,t].*eta;
   fy=ones(1,n)*snum;
   s1[.,t]=snum/(fy);
   s2s=(s1[1,t]+s1[3,t])~(s1[2,t]+s1[4,t]);
   mi_c[t,1]=(s1[1,t]*mi_f[t,1]+s1[3,t]*mi_f[t,3])/s2s[1]; 
   mi_c[t,2]=(s1[2,t]*mi_f[t,2]+s1[4,t]*mi_f[t,4])/s2s[2];

s3=zeros(n,t);   @this matrix will contain the probabilities at time t given the full information@
s3[.,t]=s1[.,t];
tim=t-1;
   do while tim>=1;  
   s3[.,tim]=s1[.,tim].*(PS*(s3[.,tim+1]./s2[.,tim+1]));   
   tim=tim-1;
   endo;
V_qm=inv(hout0*inv(I_op)*hout0);
grdn=gradfd(&TRANS,b1);
Hsn_fnl=grdn*V_qm*grdn';
SD_fnl =sqrt(diag(Hsn_fnl)); @Standard errors of the estimated coefficients@
mi_s=mi_f;
mi_s=sumc(mi_s'.*(s2));
res_f=(y-c)./sqrt(mi_s);
res[.,r]=res_f;
par_f[.,r]=trans(b1);
par_r[.,r]=b1;
se_f[.,r]=sd_fnl;
likv=-mem(b1);
k=rows(b0);
AIC=-2/t*(likv-k);
BIC=-2*likv/t+k*ln(t)/t;
hmse=sqrt(meanc(((eps^2)./mi_s-1).^2));

stat[r,.]=likv~AIC~BIC~hmse;
res_f=res_f[2:t]; t=t-1;
i=1;
   do while i<=lag;
   qm=0;
   j=1;
      do while j<=i;
     cl=corrx(res_f[j+1:t]~res_f[1:t-j]);
     cl=cl[1,2]^2;
     qm=qm+cl/(t-j);
      j=j+1;
      endo;
      qm=qm*t*(t+2);
      lb[(r-1)*2+1,i]=qm;
      lb[(r-1)*2+2,i]=cdfchic(qm,i);
            if cdfchic(qm,i)>0.05;
      lb5[r,i]=1;
      endif;
      if cdfchic(qm,i)>0.01;
      lb1[r,i]=1;
      endif;
      i=i+1;
      endo;    

s3=((s3[1,.]+s3[3,.])'~(s3[2,.]+s3[4,.])');

"estimated parameters:";
par_f[.,fs:r];
"robust standard errors:";
se_f[.,fs:r];
"Log-Lik  AIC BIC HMSE:";
stat;
"Ljung-Box Statistics and corresponding p-value from lag 1 to lag 20:";
lb;

/***********************************************************************
PROCEDURE TO REPARAMETERIZE THE COEFFICIENTS
***********************************************************************/
proc trans(x0);
local c,i,y,c1,x;
x=constr(x0);
c=x;
if holes==0;
y=exp(x);
else;
y=exp(x);
i=1;
   do while i<=rows(holes);
   y[holes[i]]=0;
   i=i+1;
   endo;
endif;
c[1:3]=abs(x[1])|abs(x[1])+abs(x[2])|abs(x[1])+abs(x[2])+abs(x[3]);
c[4]=(y[4])/(1+(y[4])+(y[5])+(y[6])/2);
c[5]=(y[5])/(1+(y[4])+(y[5])+(y[6])/2);
c[6]=(y[6])/(1+(y[4])+(y[5])+(y[6])/2);
C[5]=C[5]-C[4]-C[6]/2;
c[7:8]=(y[7:8])./(1+(y[7:8]));
c[10:11]=y[10:11];
if holes==0;
c1=zeros(pmax,1);
else;
c1=zeros(pmax,1);
i=1;
   do while i<=rh;
   c1[holes[i]]=1;
   i=i+1;
   endo;
endif;
c=delif(c,c1);  
retp(c);
endp;




proc mem(b);
local b0,omega, alpha,beta,ll,tim,mi,n,PS,D,in,s,eta,snum,fy,p11,p22,i,mi_f,mi_c,s2s,c,eps,gams,cp,gs1,gs2,xr;
b0=trans(b);
b0=constr(b0);
omega=b0[1:2]|b0[3];
alpha=b0[4];
beta=b0[5];
gam=b0[6];
p11=b0[7];
p22=b0[8];
c=b0[9];
gams=b0[10:11];
cp=b0[12:13];
    @    LOCATE 15,1;  "series " r;@

eps=y-c;
ll=0;
n=ns^2;

PS=(p11~(1-p11)~0~0)|
(0~0~(1-p22)~p22)|
(p11~(1-p11)~0~0)|
(0~0~(1-p22)~p22);

mi_f=zeros(1,n);
mi_c=zeros(1,2);
D=(eye(n)-ps')|ones(1,n);
in=zeros(n,1)|1;
s=inv(D'D)*D'in;
eta=zeros(n,1);

   xr=s[1]+s[3];
   gs1=exp(gams[1]+cp[1]*xr)/(1+exp(gams[1]+cp[1]*xr));
   gs2=exp(gams[2]+cp[2]*xr)/(1+exp(gams[2]+cp[2]*xr));

mi=(omega[1]/(1-alpha[1]-beta[1]-gam[1]/2))*gs1+(omega[2]/(1-alpha[1]-beta[1]-gam[1]/2))*(1-gs1);
mi_f[1]=mi;
eta[1]=1/sqrt(2*pi*mi)*exp(-(eps[1]^2)/(2*mi));
mi=(omega[2]/(1-alpha[1]-beta[1]-gam[1]/2))*gs2+(omega[3]/(1-alpha[1]-beta[1]-gam[1]/2))*(1-gs2);
mi_f[2]=mi;
eta[2]=1/sqrt(2*pi*mi)*exp(-(eps[1]^2)/(2*mi));
mi=(omega[1]/(1-alpha[1]-beta[1]-gam[1]/2))*gs1+(omega[2]/(1-alpha[1]-beta[1]-gam[1]/2))*(1-gs1);
mi_f[3]=mi;
eta[3]=1/sqrt(2*pi*mi)*exp(-(eps[1]^2)/(2*mi));
mi=(omega[2]/(1-alpha[1]-beta[1]-gam[1]/2))*gs2+(omega[3]/(1-alpha[1]-beta[1]-gam[1]/2))*(1-gs2);
mi_f[4]=mi;
eta[4]=1/sqrt(2*pi*mi)*exp(-(eps[1]^2)/(2*mi));
   snum=s.*eta;
   fy=ones(1,n)*snum;
   ll=ll+ln(fy);
   s=snum/(fy);
   s2s=(s[1,1]+s[3,1])~(s[2,1]+s[4,1]);
   mi_c[1,1]=(s[1,1]*mi_f[1]+s[3,1]*mi_f[3])/s2s[1]; 
   mi_c[1,2]=(s[2,1]*mi_f[2]+s[4,1]*mi_f[4])/s2s[2];
   s=ps'*s;

tim=2;
   do while tim<=t;
   xr=s[1]+s[3];
   gs1=exp(gams[1]+cp[1]*xr)/(1+exp(gams[1]+cp[1]*xr));
   gs2=exp(gams[2]+cp[2]*xr)/(1+exp(gams[2]+cp[2]*xr));
        mi=(omega[1]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs1+(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs1);
        mi_f[1]=mi;
        eta[1]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs2+(omega[3]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs2);
         mi_f[2]=mi;
        eta[2]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[1]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs1+(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs1);
         mi_f[3]=mi;
        eta[3]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs2+(omega[3]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs2);
         mi_f[4]=mi;
        eta[4]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
   snum=s.*eta;
   fy=ones(1,n)*snum;
   ll=ll+ln(fy);
   s=snum/(fy);
   s2s=(s[1,1]+s[3,1])~(s[2,1]+s[4,1]);
   mi_c[1,1]=(s[1,1]*mi_f[1]+s[3,1]*mi_f[3])/s2s[1]; 
   mi_c[1,2]=(s[2,1]*mi_f[2]+s[4,1]*mi_f[4])/s2s[2];

   s=ps'*s;
   tim=tim+1;
   endo;  

retp(-ll);
endp;   

proc sc_mem(b);
local b0,omega, alpha,beta,mi,PS,s2,eta,snum,fy,p11,p22,i,gam,n,c,eps,gams,cp,gs1,gs2;
b0=trans(b);
b0=constr(b0);
omega=b0[1:2]|b0[3];
alpha=b0[4];
beta=b0[5];
gam=b0[6];
p11=b0[7];
p22=b0[8];
c=b0[9];
gams=b0[10:11];
cp=b0[12:13];

n=ns^2;

PS=(p11~(1-p11)~0~0)|
(0~0~(1-p22)~p22)|
(p11~(1-p11)~0~0)|
(0~0~(1-p22)~p22);
eps=y-c;

   s2=ps'*s1[.,tim-1];
   eta=zeros(n,1);

   gs1=exp(gams[1]+cp[1]*xr)/(1+exp(gams[1]+cp[1]*xr));
   gs2=exp(gams[2]+cp[2]*xr)/(1+exp(gams[2]+cp[2]*xr));
        mi=(omega[1]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs1+(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs1);
        eta[1]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs2+(omega[3]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,1])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs2);
        eta[2]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[1]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs1+(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs1);
        eta[3]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));
        mi=(omega[2]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*gs2+(omega[3]+alpha[1]*(eps[tim-1]^2)+beta[1]*(mi_c[tim-1,2])+gam[1]*dum[tim-1]*(eps[tim-1]^2))*(1-gs2);
        eta[4]=1/sqrt(2*pi*mi)*exp(-(eps[tim]^2)/(2*mi));

   snum=s2.*eta;
   fy=ones(1,n)*snum;
fy=ln(fy);
retp((fy));
endp;   


/******************************************************************************
                 PROCEDURE TO CONSTRAINTS SOME PARAMETERS TO BE 0
*******************************************************************************/
proc(1)=constr(x0);
local xc,ir,ix,j;
if holes==0;
xc=x0;
else;
xc=zeros(pmax,1);
ir=1;
ix=0;
   j=1;
   do while j<=pmax;
   ix=ix+1;
      hol:
      if j==holes[ir];
      if holes[ir]==pmax and j==pmax;
      goto ehol1;
      endif;
      j=j+1;
      ix=j-ir;
      ir=ir+1;
      if ir>rh;
      ir=rh;
      goto ehol;
      endif;
      goto hol;
      endif;
   ehol:
   xc[j]=x0[ix];
   ehol1:
   j=j+1;
   endo; 
endif;
retp(xc);
endp;
